Don't free the retval, because we'll need it if the call setup looks like this:
authenticate
setcred(ESTABLISH)
setcred(DELETE)
diff -uNr Linux-PAM-0.75/modules/pam_unix/pam_unix_auth.c Linux-PAM-0.75/modules/pam_unix/pam_unix_auth.c
--- Linux-PAM-0.75/modules/pam_unix/pam_unix_auth.c	Wed Dec 20 00:15:05 2000
+++ Linux-PAM-0.75/modules/pam_unix/pam_unix_auth.c	Tue Jul 10 00:14:23 2001
@@ -46,6 +46,7 @@
 #include <unistd.h>
 #include <fcntl.h>
 #include <ctype.h>
+#include <pwd.h>
 #include <sys/types.h>
 #include <sys/stat.h>
 
@@ -85,8 +86,9 @@
 	if (on(UNIX_LIKE_AUTH, ctrl) && ret_data) {		\
 		D(("recording return code for next time [%d]",	\
 					retval));		\
+		*ret_data = retval;				\
 		pam_set_data(pamh, "unix_setcred_return",	\
-				(void *) retval, NULL);	        \
+				(void *) ret_data, NULL);	\
 	}							\
 	D(("done. [%s]", pam_strerror(pamh, retval)));		\
 	return retval;						\
@@ -201,10 +203,10 @@
 		int *pretval = NULL;
 
 		D(("recovering return code from auth call"));
-		pam_get_data(pamh, "unix_setcred_return", (const void **) pretval);
+		pam_get_data(pamh, "unix_setcred_return", (const void **) &pretval);
 		if(pretval) {
 			retval = *pretval;
-			free(pretval);
+			/* free(pretval);  We may look at it again later. */
 			D(("recovered data indicates that old retval was %d", retval));
 		}
 	}
